#include <iostream>
using namespace std;

long long CalculateNumber(long long a){

long long q=a;
int t =1;
while(a/t >= 10){
    t*=10;
}
int currentDigit=1;
long long newNum=0;
while(t >= 1){
    currentDigit = q/t;
    newNum +=  currentDigit*currentDigit;
    q-=t*currentDigit;
    t/=10;
}
return newNum;
}

int main()
{
    int T;
    cin >> T;
    long long solution[30];
    for(int i=0; i<T; i++){
        solution[i]=0;
    }
    long long n, v,a,lastNum;
    for(int i = 0; i<T; i++){
        cin >> a >> v >> n;
        lastNum = a;
        if(a==v){
            solution[i]++;
        }
        for(int t=1; t<n; t++){
                if(CalculateNumber(lastNum)==v){
                    solution[i]++;
                }
            lastNum = CalculateNumber(lastNum);
        }
    }

     for(int i=0; i<T; i++){
       cout << solution[i] << endl;
    }
    return 0;
}


